<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/SigGen.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_sig_gen_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SigGen.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;SigGenLib.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerBase.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;Data.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;filesystem&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span>siggen</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classsiggen_1_1_sig_gen.html#a80d1e476682130f9dcba8d331f9b27be">   12</a></span>&#160;    <a class="code" href="classsiggen_1_1_sig_gen.html#a80d1e476682130f9dcba8d331f9b27be">SigGen::SigGen</a> (<a class="code" href="classsiggen_1_1_options.html">Options</a> <span class="keyword">const</span> &amp; options)</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    {</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="comment">// open output file for binary (over)write</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keywordflow">if</span> (options.<a class="code" href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">GetOutputFileName</a>().length())</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;            m_OutputFile = std::make_unique&lt;File&gt;(fopen(options.<a class="code" href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">GetOutputFileName</a>().c_str(), <span class="stringliteral">&quot;w+b&quot;</span>));</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="comment">// prepare data for ThreadManager instance</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <a class="code" href="structsiggen_1_1_data.html">Data</a> data; <span class="comment">// data for thread manager, to be std::move-d from</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="comment">// prepare signature (hash) function</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a> = <a class="code" href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">HashBase::Factory</a>(options.<a class="code" href="classsiggen_1_1_options.html#a75e7b584ae17ee0010389232f1195b54">GetHashName</a>());</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Trying to open input file &quot;</span> &lt;&lt; options.<a class="code" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">GetInputFileName</a>();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        std::filesystem::path in(options.<a class="code" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">GetInputFileName</a>());</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Testing existence of input file&quot;</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">if</span> (!std::filesystem::exists(in))</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;input file does not exist&quot;</span>);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Testing regularity of input file&quot;</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordflow">if</span> (!std::filesystem::is_regular_file(in))</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;input file is not regular file&quot;</span>);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Testing size of input file&quot;</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> fileSize = std::filesystem::file_size(in);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Input file size=&quot;</span> &lt;&lt; fileSize;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#a72381ffd52528bf1d9e478a18a07f564">m_InputFileSize</a> = fileSize;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> = options.<a class="code" href="classsiggen_1_1_options.html#a1bf946ed370154884b1a82076f1b8a4a">GetBlockSize</a>();</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Input file block size=&quot;</span> &lt;&lt; data.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordtype">bool</span> <span class="keyword">const</span> full = fileSize % data.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> == 0;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> = fileSize / data.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> + (full ? 0 : 1);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Input file block count=&quot;</span> &lt;&lt; data.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="comment">// open input file for binary read</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">m_InputFile</a> = std::make_unique&lt;File&gt;(fopen(options.<a class="code" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">GetInputFileName</a>().c_str(), <span class="stringliteral">&quot;rb&quot;</span>));</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="comment">// configure threads</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keyword">const</span> hw_count = std::thread::hardware_concurrency();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> = options.<a class="code" href="classsiggen_1_1_options.html#a753c4f80f87f9a512c197afae09731fb">GetThreadCount</a>();</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Thread count from config=&quot;</span> &lt;&lt; data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> &lt;&lt; <span class="stringliteral">&quot;, detected max cores=&quot;</span> &lt;&lt; hw_count;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keywordflow">if</span> (data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> == 0)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        {</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> = hw_count;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Thread count auto-detected: &quot;</span> &lt;&lt; data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        }</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span> (data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> &gt; hw_count)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        {</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            LOGMSG(warning) &lt;&lt; <span class="stringliteral">&quot;Thread count=&quot;</span> &lt;&lt; data.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a> &lt;&lt;<span class="stringliteral">&quot; bigger than actual core count=&quot;</span> &lt;&lt; hw_count;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="comment">// create thread manager according to policy</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        m_ThreadManager = std::move(<a class="code" href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">ThreadManagerBase::Factory</a>(options.<a class="code" href="classsiggen_1_1_options.html#a261be4a780e4a23e133252e56281ddb1">GetThreadPolicy</a>(), std::move(data)));</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    }</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classsiggen_1_1_sig_gen.html#a52cb2cae015089c5a352ff33e0f72419">   68</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a52cb2cae015089c5a352ff33e0f72419">SigGen::ProcessToFile</a> ()</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    {</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        std::vector&lt;char&gt; result;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        m_ThreadManager-&gt;ProcessToBuffer(result);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <a class="code" href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">WriteOutputFile</a>(result);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    }</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classsiggen_1_1_sig_gen.html#a6683e988d1a523acda77c5fb7c5edfbf">   76</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a6683e988d1a523acda77c5fb7c5edfbf">SigGen::ProcessToBuffer</a> (std::vector&lt;char&gt; &amp; result)</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        m_ThreadManager-&gt;ProcessToBuffer(result);</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    }</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">   82</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">SigGen::WriteOutputFile</a> (std::vector&lt;char&gt; <span class="keyword">const</span> &amp; signatures)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Writing results to output file&quot;</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> result_size = signatures.size();</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> wrote_size = m_OutputFile-&gt;TryWrite(signatures.data(), signatures.size());</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Wrote &quot;</span> &lt;&lt; wrote_size &lt;&lt; <span class="stringliteral">&quot; Bytes out of total &quot;</span> &lt;&lt; result_size &lt;&lt; <span class="stringliteral">&quot; Bytes&quot;</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keywordflow">if</span> (wrote_size &lt; result_size)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Cannot write signature to output file&quot;</span>);</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        }</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_options_html_a261be4a780e4a23e133252e56281ddb1"><div class="ttname"><a href="classsiggen_1_1_options.html#a261be4a780e4a23e133252e56281ddb1">siggen::Options::GetThreadPolicy</a></div><div class="ttdeci">ThreadingPolicy GetThreadPolicy() const</div><div class="ttdoc">return user specified threading policy</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00041">Options.h:41</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a75e7b584ae17ee0010389232f1195b54"><div class="ttname"><a href="classsiggen_1_1_options.html#a75e7b584ae17ee0010389232f1195b54">siggen::Options::GetHashName</a></div><div class="ttdeci">const std::string &amp; GetHashName() const</div><div class="ttdoc">return user specified hash function name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00045">Options.h:45</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html"><div class="ttname"><a href="classsiggen_1_1_options.html">siggen::Options</a></div><div class="ttdoc">configuration for generation of signatures file</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00020">Options.h:20</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_aaf8091edab7f24f7b6f725f6abbacc23"><div class="ttname"><a href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">siggen::Data::m_InputBlockCount</a></div><div class="ttdeci">size_t m_InputBlockCount</div><div class="ttdoc">block count (number of generated signatures)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00016">Data.h:16</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a72381ffd52528bf1d9e478a18a07f564"><div class="ttname"><a href="structsiggen_1_1_data.html#a72381ffd52528bf1d9e478a18a07f564">siggen::Data::m_InputFileSize</a></div><div class="ttdeci">size_t m_InputFileSize</div><div class="ttdoc">file size in bytes</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00015">Data.h:15</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a753c4f80f87f9a512c197afae09731fb"><div class="ttname"><a href="classsiggen_1_1_options.html#a753c4f80f87f9a512c197afae09731fb">siggen::Options::GetThreadCount</a></div><div class="ttdeci">uint32_t GetThreadCount() const</div><div class="ttdoc">return user specified number of threads (0 == auto)</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00039">Options.h:39</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a93b4e1f79b1751cd74e8069639709467"><div class="ttname"><a href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">siggen::Options::GetInputFileName</a></div><div class="ttdeci">const std::string &amp; GetInputFileName() const</div><div class="ttdoc">return user specified input file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00033">Options.h:33</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a06a7600d0e0634bbb0275b81589fd5aa"><div class="ttname"><a href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">siggen::Data::m_Hash</a></div><div class="ttdeci">std::unique_ptr&lt; HashBase &gt; m_Hash</div><div class="ttdoc">signature function</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00020">Data.h:20</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_base_html_acb6c87062d2f75f4ad9d21801950e61e"><div class="ttname"><a href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">siggen::ThreadManagerBase::Factory</a></div><div class="ttdeci">static std::unique_ptr&lt; ThreadManagerBase &gt; Factory(ThreadingPolicy policy, Data &amp;&amp;data)</div><div class="ttdoc">creates threading manager according to ThreadingPolicy</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_base_8cpp_source.html#l00011">ThreadManagerBase.cpp:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a52cb2cae015089c5a352ff33e0f72419"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a52cb2cae015089c5a352ff33e0f72419">siggen::SigGen::ProcessToFile</a></div><div class="ttdeci">void ProcessToFile()</div><div class="ttdoc">reads input file block after block and generate signature for each one</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00068">SigGen.cpp:68</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a1006e97814f7d32c8668575d56ba8bdf"><div class="ttname"><a href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">siggen::Data::m_BlockSize</a></div><div class="ttdeci">size_t m_BlockSize</div><div class="ttdoc">block size specified from options</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00014">Data.h:14</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a10d14f9813765c6f31080355bad10dbd"><div class="ttname"><a href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">siggen::Data::m_ThreadCount</a></div><div class="ttdeci">uint32_t m_ThreadCount</div><div class="ttdoc">thread count</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00017">Data.h:17</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html"><div class="ttname"><a href="structsiggen_1_1_data.html">siggen::Data</a></div><div class="ttdoc">provides threading manager with necessary data to work with</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00012">Data.h:12</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a09582db7e870dfdd031c9076338384cb"><div class="ttname"><a href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">siggen::Data::m_InputFile</a></div><div class="ttdeci">std::unique_ptr&lt; File &gt; m_InputFile</div><div class="ttdoc">input file (binary)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00019">Data.h:19</a></div></div>
<div class="ttc" id="astructsiggen_1_1_hash_base_html_a1f67711fe8ce2ae59a0fd8f33f6b51a2"><div class="ttname"><a href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">siggen::HashBase::Factory</a></div><div class="ttdeci">static std::unique_ptr&lt; HashBase &gt; Factory(std::string const &amp;name)</div><div class="ttdoc">creates hash according to specified name</div><div class="ttdef"><b>Definition:</b> <a href="_hash_base_8cpp_source.html#l00011">HashBase.cpp:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a80d1e476682130f9dcba8d331f9b27be"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a80d1e476682130f9dcba8d331f9b27be">siggen::SigGen::SigGen</a></div><div class="ttdeci">SigGen(Options const &amp;options)</div><div class="ttdoc">generates signature from input file and writes result to output file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00012">SigGen.cpp:12</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a6683e988d1a523acda77c5fb7c5edfbf"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a6683e988d1a523acda77c5fb7c5edfbf">siggen::SigGen::ProcessToBuffer</a></div><div class="ttdeci">void ProcessToBuffer(std::vector&lt; char &gt; &amp;result)</div><div class="ttdoc">reads input file block after block and generate signature for each one</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00076">SigGen.cpp:76</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a1bf946ed370154884b1a82076f1b8a4a"><div class="ttname"><a href="classsiggen_1_1_options.html#a1bf946ed370154884b1a82076f1b8a4a">siggen::Options::GetBlockSize</a></div><div class="ttdeci">size_t GetBlockSize() const</div><div class="ttdoc">return user specified block size</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00037">Options.h:37</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_aecd9d4cc9b7d8186f6e81de6d2eb3ffe"><div class="ttname"><a href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">siggen::Options::GetOutputFileName</a></div><div class="ttdeci">const std::string &amp; GetOutputFileName() const</div><div class="ttdoc">return user specified output file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00035">Options.h:35</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a5d1a3b3fb8500415bc93a8ce9e62ef5c"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">siggen::SigGen::WriteOutputFile</a></div><div class="ttdeci">void WriteOutputFile(std::vector&lt; char &gt; const &amp;signatures)</div><div class="ttdoc">writes signature from memory to file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00082">SigGen.cpp:82</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>SigGen.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
